<template>
  <div>
    <slot />
  </div>
</template>

<script>
export default {
    props: {
        options: {
          type: Object,
          default: () => {},
        },
        autoInit: {
            type: Boolean,
            default: true,
        },
    },
    data() {
        return {
            $flickity: null,
        };
    },

    mounted() {
        if (this.autoInit) {
          this.init();
        }
    },

    beforeDestroy() {
        if (this.$flickity) {
          setTimeout(() => {
              this.$flickity.destroy();
              this.$flickity = null;
          }, 1000);
        }
    },

    methods: {
        init() {
            const Flickity = require('flickity'); // eslint-disable-line global-require

            this.$flickity = new Flickity(this.$el, this.options);
            this.$flickity.on('dragStart', () => {this.$flickity.slider.style.pointerEvents = 'none'});
            this.$flickity.on('dragEnd', () => {this.$flickity.slider.style.pointerEvents = 'auto'});
            this.$emit('init', this.$flickity);
        },

        flickity() {
            return this.$flickity;
        },

        select(index, isWrapped, isInstant) {
            this.$flickity.select(index, isWrapped, isInstant);
        },

        next(isWrapped, isInstant) {
            this.$flickity.next(isWrapped, isInstant);
        },

        previous(isWrapped, isInstant) {
            this.$flickity.previous(isWrapped, isInstant);
        },

        selectCell(value, isWrapped, isInstant) {
            this.$flickity.selectCell(value, isWrapped, isInstant);
        },

        resize() {
            this.$flickity.resize();
        },

        reposition() {
            this.$flickity.reposition();
        },

        prepend(elements) {
            this.$flickity.prepend(elements);
        },

        append(elements) {
            this.$flickity.append(elements);
        },

        insert(elements, index) {
            this.$flickity.insert(elements, index);
        },

        remove(elements) {
            this.$flickity.remove(elements);
        },

        playPlayer() {
            this.$flickity.playPlayer();
        },

        stopPlayer() {
            this.$flickity.stopPlayer();
        },

        pausePlayer() {
            this.$flickity.pausePlayer();
        },

        unpausePlayer() {
            this.$flickity.unpausePlayer();
        },

        rerender() {
            if (this.$flickity) {
                this.$flickity.destroy();
            }
            this.init();
        },

        destroy() {
            this.$flickity.destroy();
        },

        reloadCells() {
            this.$flickity.reloadCells();
        },

        getCellElements() {
            return this.$flickity.getCellElements();
        },

        data() {
            const Flickity = require('flickity'); // eslint-disable-line global-require

            return Flickity.data(this.$el);
        },

        on(eventName, listener) {
            this.$flickity.on(eventName, listener);
        },

        off(eventName, listener) {
            this.$flickity.off(eventName, listener);
        },

        once(eventName, listener) {
            this.$flickity.once(eventName, listener);
        },

        selectedElement() {
            return this.$flickity.selectedElement;
        },

        selectedElements() {
            return this.$flickity.selectedElements;
        },

        selectedIndex() {
            return this.$flickity.selectedIndex;
        },

        cells() {
            return this.$flickity.cells;
        },

        slides() {
            return this.$flickity.slides;
        },

        disableDrag() {
            this.$flickity.options.draggable = false;
            this.$flickity.updateDraggable();
        },

        enableDrag() {
            this.$flickity.options.draggable = true;
            this.$flickity.updateDraggable();
        },
    },
};
</script>

<style src="../../node_modules/flickity/css/flickity.css"></style>
<style lang="scss">
.mobile-fullwidth {
  width: calc(100% + #{$grid-gutter-width});
  margin-left: -#{$grid-gutter-width / 2};
  margin-right: -#{$grid-gutter-width / 2};

  .text-wrapper {
    margin-left: #{$grid-gutter-width / 2};
    margin-right: #{$grid-gutter-width / 2};
  }

  @include media-breakpoint-up(md) {
    width: 100%;
    margin-left: 0;
    margin-right: 0;

    .text-wrapper {
      margin-left: 0;
      margin-right: 0;
    }
  }
}

.flickity {
  position: relative;

  &.loaded {
    &.equal-heights {
      .carousel-cell {
        @include media-breakpoint-up(lg) {
          height: 100%;

          > .row {
            height: 100%;
          }
        }
      }
    }
  }
}

.flickity-viewport {
  &:focus-visible {
    outline: none;
  }
}

.flickity-button {
  &:focus {
    outline: none;
    box-shadow: none;
  }
}

.flickity-prev-next-button {
  display: none;
  width: 3rem;
  height: 3rem;
  padding: 0;
  border-radius: 0;
  background-color: transparent;

  @include media-breakpoint-up(md) {
    display: block;
  }

  &:hover {
    background: transparent;
  }

  &.previous {
    left: 0px;
  }

  &.next {
    right: 0px;
  }

  .flickity-button-icon {
    left: 0.25rem;
    top: 0.25rem;
    width: auto;
    height: 2.5rem;
  }
}

.flickity-page-dots {
  bottom: 0;
  padding: 7px 0;
  padding-bottom: calc(4rem + 7px);

  @include media-breakpoint-up(md) {
    display: none;
  }

  .dot {
    background-color: $black;
    opacity: 1;
    width: 0.75rem;
    height: 0.75rem;

    &.is-selected {
      background-color: $red;
    }
  }
}

.carousel-cell {
  width: 100%;
}

.text-wrapper {
  display: flex;
  flex-direction: column;
  justify-content: center;
  height: calc(100% - 2rem);
  margin: 1rem 0;

  @include media-breakpoint-up(md) {
    height: calc(100% - 12.5rem);
    margin: 6rem 0 6.5rem;
  }
}

.img-wrapper {
  height: 100%;
  background-color: $gray;
}

.slider-image {
  &.cover {
    height: 100%;

    img {
      @include media-breakpoint-up(md) {
        object-fit: cover;
        max-height: none;
        height: 100%;
      }
    }
  }
}

.flickity-mobile-controls {
  padding: 2rem 1rem 4rem;
  display: flex;
  justify-content: center;
  align-items: center;

  @include media-breakpoint-up(md) {
    display: none;
  }

  .flickity-prev-next-button {
    display: none;
    position: relative;
    transform: none;
    left: auto;
    top: auto;
    right: auto;
    width: 3rem;
    height: 1.5rem;
    flex-grow: 0;
    flex-shrink: 0;

    &.previous {
      svg {
        transform: rotate(-180deg);
      }
    }
  }

  .flickity-page-dots {
    position: relative;
    width: auto;
    margin: 0 1.5rem;
    padding: 0;
  }
}
</style>
